/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.ergebniskonflikt.entity;

@javax.persistence.NamedQueries(
 {



   
      @javax.persistence.NamedQuery(
     name="ERGEBNIS_KONFLIKT.ErgebnisOrderById",
     query="SELECT k FROM ErgebnisKonflikt k WHERE k.ergebnis = ?1 ORDER BY k.id",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "ERGEBNIS_KONFLIKT")
// @javax.persistence.IdClass(ErgebnisKonfliktPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class ErgebnisKonflikt
extends AbstractErgebnisKonflikt
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor (protected, da mit CustomData aufgerufen werden muss)
   */
  protected ErgebnisKonflikt() {
    super();
  }
    public ErgebnisKonflikt(de.ivu.elect.jee.entity.customdata.CustomData customData){
                      if (customData != null && de.ivu.elect.jee.entity.customdata.EmptyCustomData.INSTANCE != customData) {
          customData.setTechnicalEntity(this);
          customDataStorage = new de.ivu.elect.business.customdata.entity.CustomDataStorage(customData);
        }
            }



    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public ErgebnisKonflikt(ErgebnisKonflikt original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "ergebnis_konflikt_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "ErgebnisKonflikt")
    @javax.persistence.TableGenerator(name = "ErgebnisKonflikt", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "ErgebnisKonflikt", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient ErgebnisKonfliktPK pkCache;

  @Override
  public ErgebnisKonfliktPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new ErgebnisKonfliktPK(getId());
    }

    return pkCache;
  }

  public static <E extends ErgebnisKonflikt> java.util.Map<ErgebnisKonfliktPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<ErgebnisKonfliktPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends ErgebnisKonflikt> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedErgebnisKonfliktArt = false;
          hasChangedErgebnisKonfliktStatus = false;
          hasChangedKonfliktBeschreibung = false;
          hasChangedLoesungBeschreibung = false;
          hasChangedLoesungVon = false;
          hasChangedLoesungZeitpunkt = false;
  
      hasChangedCustomDataStorage = false;
        hasChangedErgebnis = false;
  


    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "ERGEBNIS_KONFLIKT_ART", nullable = ErgebnisKonfliktConstants.ERGEBNIS_KONFLIKT_ART_NULLABLE)
    
  protected de.ivu.elect.business.ergebnis.entity.ErgebnisKonfliktArt ergebnisKonfliktArt =  de.ivu.elect.business.ergebnis.entity.ErgebnisKonfliktArt.UNBEKANNT;

  @javax.persistence.Transient
  protected boolean hasChangedErgebnisKonfliktArt = false;

  public boolean hasChangedErgebnisKonfliktArt(){
    return hasChangedErgebnisKonfliktArt;
  }
  
  /**
   * 
   *
   * getter for ERGEBNIS_KONFLIKT.ERGEBNIS_KONFLIKT_ART
   */
    @Override   public  de.ivu.elect.business.ergebnis.entity.ErgebnisKonfliktArt getErgebnisKonfliktArt() {
        return ergebnisKonfliktArt;
      }

  /**
   * 
   *
   * setter for ERGEBNIS_KONFLIKT.ERGEBNIS_KONFLIKT_ART
   *
   * @param ergebnisKonfliktArt
   */
  @Override   public void setErgebnisKonfliktArt( de.ivu.elect.business.ergebnis.entity.ErgebnisKonfliktArt ergebnisKonfliktArt) {

       resetTkCache();
                  de.ivu.elect.business.ergebnis.entity.ErgebnisKonfliktArt ergebnisKonfliktArtInternal = ergebnisKonfliktArt;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.ergebnisKonfliktArt
      , ergebnisKonfliktArtInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedErgebnisKonfliktArt |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("ergebnisKonfliktArt");
      }


      

       this.ergebnisKonfliktArt = ergebnisKonfliktArtInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "ERGEBNIS_KONFLIKT_STATUS", nullable = ErgebnisKonfliktConstants.ERGEBNIS_KONFLIKT_STATUS_NULLABLE)
    
  protected de.ivu.elect.business.ergebnis.entity.ErgebnisKonfliktStatus ergebnisKonfliktStatus =  de.ivu.elect.business.ergebnis.entity.ErgebnisKonfliktStatus.UNGELOEST;

  @javax.persistence.Transient
  protected boolean hasChangedErgebnisKonfliktStatus = false;

  public boolean hasChangedErgebnisKonfliktStatus(){
    return hasChangedErgebnisKonfliktStatus;
  }
  
  /**
   * 
   *
   * getter for ERGEBNIS_KONFLIKT.ERGEBNIS_KONFLIKT_STATUS
   */
    @Override   public  de.ivu.elect.business.ergebnis.entity.ErgebnisKonfliktStatus getErgebnisKonfliktStatus() {
        return ergebnisKonfliktStatus;
      }

  /**
   * 
   *
   * setter for ERGEBNIS_KONFLIKT.ERGEBNIS_KONFLIKT_STATUS
   *
   * @param ergebnisKonfliktStatus
   */
  @Override   public void setErgebnisKonfliktStatus( de.ivu.elect.business.ergebnis.entity.ErgebnisKonfliktStatus ergebnisKonfliktStatus) {

       resetTkCache();
                  de.ivu.elect.business.ergebnis.entity.ErgebnisKonfliktStatus ergebnisKonfliktStatusInternal = ergebnisKonfliktStatus;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.ergebnisKonfliktStatus
      , ergebnisKonfliktStatusInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedErgebnisKonfliktStatus |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("ergebnisKonfliktStatus");
      }


      

       this.ergebnisKonfliktStatus = ergebnisKonfliktStatusInternal;

         }

        
  @javax.persistence.Basic(fetch=javax.persistence.FetchType.LAZY)
  @javax.persistence.Lob
  @javax.persistence.Column(name = "KONFLIKT_BESCHREIBUNG", nullable = ErgebnisKonfliktConstants.KONFLIKT_BESCHREIBUNG_NULLABLE, length = Integer.MAX_VALUE)
    
  protected java.lang.String konfliktBeschreibung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedKonfliktBeschreibung = false;

  public boolean hasChangedKonfliktBeschreibung(){
    return hasChangedKonfliktBeschreibung;
  }
  
  /**
   * 
   *
   * getter for ERGEBNIS_KONFLIKT.KONFLIKT_BESCHREIBUNG
   *
   * (LAZY LOADING)
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getKonfliktBeschreibung() {
        return konfliktBeschreibung;
      }

  /**
   * 
   *
   * setter for ERGEBNIS_KONFLIKT.KONFLIKT_BESCHREIBUNG
   *
   * @param konfliktBeschreibung
   */
  @Override   public void setKonfliktBeschreibung(@javax.annotation.Nullable  java.lang.String konfliktBeschreibung) {

       resetTkCache();
                  java.lang.String konfliktBeschreibungInternal = org.apache.commons.lang3.StringUtils.trimToNull(konfliktBeschreibung);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.konfliktBeschreibung
      , konfliktBeschreibungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedKonfliktBeschreibung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("konfliktBeschreibung");
      }


      

       this.konfliktBeschreibung = konfliktBeschreibungInternal;

         }

        
  @javax.persistence.Basic(fetch=javax.persistence.FetchType.LAZY)
  @javax.persistence.Lob
  @javax.persistence.Column(name = "LOESUNG_BESCHREIBUNG", nullable = ErgebnisKonfliktConstants.LOESUNG_BESCHREIBUNG_NULLABLE, length = Integer.MAX_VALUE)
    
  protected java.lang.String loesungBeschreibung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedLoesungBeschreibung = false;

  public boolean hasChangedLoesungBeschreibung(){
    return hasChangedLoesungBeschreibung;
  }
  
  /**
   * 
   *
   * getter for ERGEBNIS_KONFLIKT.LOESUNG_BESCHREIBUNG
   *
   * (LAZY LOADING)
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getLoesungBeschreibung() {
        return loesungBeschreibung;
      }

  /**
   * 
   *
   * setter for ERGEBNIS_KONFLIKT.LOESUNG_BESCHREIBUNG
   *
   * @param loesungBeschreibung
   */
  @Override   public void setLoesungBeschreibung(@javax.annotation.Nullable  java.lang.String loesungBeschreibung) {

       resetTkCache();
                  java.lang.String loesungBeschreibungInternal = org.apache.commons.lang3.StringUtils.trimToNull(loesungBeschreibung);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.loesungBeschreibung
      , loesungBeschreibungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedLoesungBeschreibung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("loesungBeschreibung");
      }


      

       this.loesungBeschreibung = loesungBeschreibungInternal;

         }

        
  @javax.persistence.Column(name = "LOESUNG_VON", nullable = ErgebnisKonfliktConstants.LOESUNG_VON_NULLABLE, length=ErgebnisKonfliktConstants.LOESUNG_VON_MAX_LENGTH)
        
  protected java.lang.String loesungVon =  null;

  @javax.persistence.Transient
  protected boolean hasChangedLoesungVon = false;

  public boolean hasChangedLoesungVon(){
    return hasChangedLoesungVon;
  }
  
  /**
   * 
   *
   * getter for ERGEBNIS_KONFLIKT.LOESUNG_VON
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getLoesungVon() {
        return loesungVon;
      }

  /**
   * 
   *
   * setter for ERGEBNIS_KONFLIKT.LOESUNG_VON
   *
   * @param loesungVon
   */
  @Override   public void setLoesungVon(@javax.annotation.Nullable  java.lang.String loesungVon) {

       resetTkCache();
                  
                          java.lang.String loesungVonInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(loesungVon, ErgebnisKonfliktConstants.LOESUNG_VON_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.loesungVon
      , loesungVonInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedLoesungVon |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("loesungVon");
      }


      

       this.loesungVon = loesungVonInternal;

         }

        
  @javax.persistence.Temporal(javax.persistence.TemporalType.TIMESTAMP)
  @javax.persistence.Column(name = "LOESUNG_ZEITPUNKT", nullable = ErgebnisKonfliktConstants.LOESUNG_ZEITPUNKT_NULLABLE, precision=ErgebnisKonfliktConstants.LOESUNG_ZEITPUNKT_PRECISION)
    
  protected java.util.Date loesungZeitpunkt =  null;

  @javax.persistence.Transient
  protected boolean hasChangedLoesungZeitpunkt = false;

  public boolean hasChangedLoesungZeitpunkt(){
    return hasChangedLoesungZeitpunkt;
  }
  
  /**
   * 
   *
   * getter for ERGEBNIS_KONFLIKT.LOESUNG_ZEITPUNKT
   */
  @javax.annotation.Nullable   @Override   public  java.util.Date getLoesungZeitpunkt() {
              if (loesungZeitpunkt == null){
            return null;
          } else {
                          return loesungZeitpunkt;
          }
      }

  /**
   * 
   *
   * setter for ERGEBNIS_KONFLIKT.LOESUNG_ZEITPUNKT
   *
   * @param loesungZeitpunkt
   */
  @Override   public void setLoesungZeitpunkt(@javax.annotation.Nullable  java.util.Date loesungZeitpunkt) {

       resetTkCache();
                  java.util.Date loesungZeitpunktInternal = de.ivu.elect.jee.entity.EntityUtil.normalizeDateTime(loesungZeitpunkt);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.loesungZeitpunkt
      , loesungZeitpunktInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedLoesungZeitpunkt |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("loesungZeitpunkt");
      }


      

       this.loesungZeitpunkt = loesungZeitpunktInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu CustomDataStorage
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "CUSTOM_DATA_STORAGE_ID", referencedColumnName="CUSTOM_DATA_STORAGE_ID"))
  protected de.ivu.elect.business.customdata.entity.CustomDataStorage customDataStorage;

  /**
   * 
   */
  @Override
  public void setCustomDataStorage(@javax.annotation.Nullable  de.ivu.elect.business.customdata.entity.CustomDataStorage customDataStorage){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.customDataStorage
    , customDataStorage);

    attributeChanged |= thisAttributChanged;

    hasChangedCustomDataStorage |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("customDataStorage");
    }

    this.customDataStorage = customDataStorage;
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.customdata.entity.CustomDataStorage getCustomDataStorage(){
    return this.customDataStorage;
  }

  @javax.persistence.Transient
  protected boolean hasChangedCustomDataStorage = false;

  public boolean hasChangedCustomDataStorage(){
    return hasChangedCustomDataStorage;
  }

  /**
   * Beziehung (unidirektional) zu Ergebnis
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "ERGEBNIS_ID", referencedColumnName="ERGEBNIS_ID"))
  protected de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis;

  /**
   * 
   */
  @Override
  public void setErgebnis( de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.ergebnis
    , ergebnis);

    attributeChanged |= thisAttributChanged;

    hasChangedErgebnis |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("ergebnis");
    }

    this.ergebnis = ergebnis;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.ergebnis.entity.Ergebnis getErgebnis(){
    return this.ergebnis;
  }

  @javax.persistence.Transient
  protected boolean hasChangedErgebnis = false;

  public boolean hasChangedErgebnis(){
    return hasChangedErgebnis;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("ErgebnisKonflikt:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(ErgebnisKonflikt other){
                             other.ergebnisKonfliktArt = this.ergebnisKonfliktArt;
                                other.ergebnisKonfliktStatus = this.ergebnisKonfliktStatus;
                                other.konfliktBeschreibung = this.konfliktBeschreibung;
                                other.loesungBeschreibung = this.loesungBeschreibung;
                                other.loesungVon = this.loesungVon;
                                other.loesungZeitpunkt = this.loesungZeitpunkt;
           
  other.setCustomDataStorage(this.getCustomDataStorage());
  other.setErgebnis(this.getErgebnis());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(ErgebnisKonflikt.class)){
        copyEntityAttributesUsingSetter((ErgebnisKonflikt) other.castTo(ErgebnisKonflikt.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von ErgebnisKonflikt: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(ErgebnisKonflikt other){
               other.setErgebnisKonfliktArt(this.ergebnisKonfliktArt);
                  other.setErgebnisKonfliktStatus(this.ergebnisKonfliktStatus);
                  other.setKonfliktBeschreibung(this.konfliktBeschreibung);
                  other.setLoesungBeschreibung(this.loesungBeschreibung);
                  other.setLoesungVon(this.loesungVon);
                  other.setLoesungZeitpunkt(this.loesungZeitpunkt);
           other.setCustomDataXml(this.getCustomDataXml());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(ErgebnisKonflikt other){
                       if (hasChangedErgebnisKonfliktArt) {
        other.setErgebnisKonfliktArt(this.ergebnisKonfliktArt);
      }
                             if (hasChangedErgebnisKonfliktStatus) {
        other.setErgebnisKonfliktStatus(this.ergebnisKonfliktStatus);
      }
                             if (hasChangedKonfliktBeschreibung) {
        other.setKonfliktBeschreibung(this.konfliktBeschreibung);
      }
                             if (hasChangedLoesungBeschreibung) {
        other.setLoesungBeschreibung(this.loesungBeschreibung);
      }
                             if (hasChangedLoesungVon) {
        other.setLoesungVon(this.loesungVon);
      }
                             if (hasChangedLoesungZeitpunkt) {
        other.setLoesungZeitpunkt(this.loesungZeitpunkt);
      }
             }




    /**
    * Hat die Entität überhaupt einen CustomDataStorage?
    */
    private boolean isCustomDataSupported() {
      return getCustomDataStorage()!=null;
    }

    @Override
    public de.ivu.elect.jee.entity.customdata.CustomData getCustomData() {
      if (isCustomDataSupported()) {
        de.ivu.elect.jee.entity.customdata.CustomData result = getCustomDataStorage().getCustomData();
        result.setTechnicalEntity(this); // Fachliche Entität bei jedem Zugriff setzen
        return result;
      }
      return de.ivu.elect.jee.entity.customdata.EmptyCustomData.INSTANCE;
    }


    @Override
    @SuppressWarnings("unchecked")
    public <T extends de.ivu.elect.jee.entity.customdata.CustomData> T getCustomData(Class<T> clazz) {
      if (isCustomDataSupported()) {
        return (T) getCustomData();
      }
      throw new IllegalStateException("Entität ErgebnisKonflikt besitzt kein CustomDataStorage: "+this);
    }


    @Override
    public void updateCustomData() {
      if (isCustomDataSupported()) {
        getCustomDataStorage().updateCustomData();
      }
    }


    public void clearCustomDataCache() {
      if (isCustomDataSupported()) {
        getCustomDataStorage().clearCustomDataCache();
      }
    }

    public String getCustomDataXml(){
      if (isCustomDataSupported()) {
        return getCustomDataStorage().getCustomDataXml();
      }
      return "";
    }

    public void setCustomDataXml(String customDataXml){
      if (isCustomDataSupported()) {
        if (org.apache.commons.lang3.StringUtils.isBlank(customDataXml)) {
          if (de.ivu.elect.business.system.control.FailOnUnkownCustomData.FAIL_ON_UNKNOWN_CUSTOM_DATA) {
            throw new IllegalStateException("Entität ErgebnisKonflikt hat CustomDataStorage, soll aber kein CustomData aufnehmen: '"+customDataXml+"'");
          }
          // ELECTMUC-2581
          System.err.println("Entität ErgebnisKonflikt hat CustomDataStorage, soll aber kein CustomData aufnehmen: '"+customDataXml+"'");
        } else {
          getCustomDataStorage().setCustomDataXml(customDataXml);
        }
        clearCustomDataCache(); // WASDE-1131
      } else {
       if (org.apache.commons.lang3.StringUtils.isNotBlank(customDataXml)) {
         if (customDataXml.endsWith("EmptyCustomData/>")) {
            // Abwärtskompatibilität...alles gut, die alten, leeren CustomDataObjekte...
         } else {
           if (de.ivu.elect.business.system.control.FailOnUnkownCustomData.FAIL_ON_UNKNOWN_CUSTOM_DATA) {
             throw new IllegalStateException("Entität ErgebnisKonflikt hat kein CustomDataStorage, soll aber CustomData aufnehmen: '"+customDataXml+"'");
           }
           // ELECT-5122
           System.err.println("Entität ErgebnisKonflikt hat kein CustomDataStorage, soll aber CustomData aufnehmen: '"+customDataXml+"'");
         }
       }
      }
    }

    public boolean hasChangedCustomDataXml() {
      if (isCustomDataSupported()) {
        return getCustomDataStorage().hasChangedCustomDataXml();
      }
      return false;
    }


    @javax.persistence.Transient
    private transient ErgebnisKonfliktTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public ErgebnisKonfliktTK getErgebnisKonfliktTK(){
    if (tkCache==null) {
    tkCache = new ErgebnisKonfliktTK(



  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getErgebnisKonfliktTK();
    }

  @Override
  public ErgebnisKonfliktUK getUk(){
    return getErgebnisKonfliktUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return ErgebnisKonflikt.class;
  }

public ErgebnisKonfliktUK getErgebnisKonfliktUK(){

   return  new ErgebnisKonfliktUK(



  );
}

  @javax.persistence.Transient
  private transient ErgebnisKonfliktProperties properties;

  public ErgebnisKonfliktProperties getProperties(){
    if (properties == null) {
      properties = new ErgebnisKonfliktProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public ErgebnisKonfliktProperties getErgebnisKonfliktProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return ErgebnisKonfliktConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return false;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
                                                         }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                                                                                                                                    return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                                                                                                               }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "ERGEBNIS_KONFLIKT";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "ErgebnisKonflikt";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(ergebnisKonfliktArt, this, ErgebnisKonfliktConstants.MESSAGE_KEY_ERGEBNIS_KONFLIKT_ART_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(ergebnisKonfliktStatus, this, ErgebnisKonfliktConstants.MESSAGE_KEY_ERGEBNIS_KONFLIKT_STATUS_EINZAHL, validationResult);
                                                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(ErgebnisKonfliktConstants.KONFLIKT_BESCHREIBUNG_MAX_LENGTH ,  konfliktBeschreibung, this, ErgebnisKonfliktConstants.MESSAGE_KEY_KONFLIKT_BESCHREIBUNG_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(ErgebnisKonfliktConstants.LOESUNG_BESCHREIBUNG_MAX_LENGTH ,  loesungBeschreibung, this, ErgebnisKonfliktConstants.MESSAGE_KEY_LOESUNG_BESCHREIBUNG_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(ErgebnisKonfliktConstants.LOESUNG_VON_MAX_LENGTH ,  loesungVon, this, ErgebnisKonfliktConstants.MESSAGE_KEY_LOESUNG_VON_EINZAHL, validationResult);
                                                                                             }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
